<template>
  <div
    class="group relative flex h-4 w-5 flex-col items-center justify-between [&_span]:pointer-events-none [&_span]:h-1 [&_span]:w-1 [&_span]:rounded-full [&_span]:bg-slate-400 [&_span]:transition-all"
  >
    <input
      ref="target"
      v-model="value"
      type="checkbox"
      class="peer absolute h-full w-full cursor-pointer opacity-0"
      tabindex="-1"
      @input="toggle"
    />
    <span
      class="group-hover:bg-fuchsia-500 group-active:scale-90 peer-checked:w-full peer-checked:origin-[100%_0%] peer-checked:-rotate-45"
    />
    <span
      class="group-hover:bg-fuchsia-500 group-active:scale-90 peer-checked:origin-center peer-checked:opacity-0"
    />
    <span
      class="group-hover:bg-fuchsia-500 group-active:scale-90 peer-checked:w-full peer-checked:origin-[95%_100%] peer-checked:rotate-45"
    />
  </div>
</template>

<script lang="ts" setup>
const props = withDefaults(
  defineProps<{
    shown: boolean;
  }>(),
  { shown: false },
);
const emit = defineEmits<{
  (e: 'toggle', elem: boolean): void;
}>();

const value = ref(props.shown);
watch(props, ({ shown }) => (value.value = shown));

const toggle = (e: Event) => {
  e.preventDefault();
  const { checked } = e.target as HTMLInputElement;
  emit('toggle', checked);
};
</script>
